{% macro include_saml() %}{% include "nginx-service-saml.j2" %}{% endmacro %}
{% macro include_probing() %}{% include "nginx-service-probing.j2" %}{% endmacro %}
{% macro include_mapping(mapping) %}{% include "nginx-service-mapping.j2" %}{% endmacro %}

###############################################################################
### SERVER: SERVICE {{ service["host"] }}:{{ service["port"] }}
###############################################################################

server {
  server_name {{ service["host"] }};
  listen {{ service["port"] }};
  http2 on;

  real_ip_header X-Forwarded-For;
  real_ip_recursive on;

  {%- for cidr in trusted_ips %}
  set_real_ip_from {{ cidr }};
  {%- endfor %}

  ##############################################################################
  ### Default cache configuration

  proxy_cache_bypass $http_pragma $http_cache_control;
  proxy_cache {{ cache_zone }};
  proxy_cache_revalidate on;

  ##############################################################################
  ### Default compression configuration

  gzip on;

  {%- if nginx_plus_enabled and saml_enabled %}
  ##############################################################################
  ### SAML Configuration

  {{ include_saml() | indent(2) }}
  {%- endif %}

  ##############################################################################
  ### Default proxy configuration

  proxy_http_version 1.1;
  set $default_sorry "https://sorry.ec.europa.eu";

  {{ include_probing() | indent(2) }}

{% for mapping in service["mappings"] %}
  {{ include_mapping(mapping) | indent(2) }}
{% endfor %}
}
